#include "predef.h" 
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <taskmon.h>
#include <smarttrap.h>
#include <../mod5270/system/sim5270.h>
#include <stdlib.h> 

extern "C" {
void SetIntc( long func, int vector, int level, int prio );
void NMI_C_Part(); // The part of the ISR written in C/C++
void NMI_ASM_Part(); // The part of the ISR written in Assembly
}

DWORD Addresses[25000];

volatile DWORD isr_cnt;
volatile PDWORD saved_a7;

void Function_Holder()
{
__asm__ (" .global NMI_ASM_Part"); // export the label for ASM part
__asm__ (" .extern NMI_C_Part"); // label for the C part of the ISR
__asm__ (" .extern saved_a7"); // label for the C part of the ISR
__asm__ ("NMI_ASM_Part:"); // label for the assembly part of the ISR
__asm__ (" move.w #0x2700,%sr "); // set the IRQ mask to mask all
__asm__ (" move.l %a7,saved_a7 ");
__asm__ (" lea -60(%a7),%a7 "); // make space on the system stack
__asm__ (" movem.l %d0-%d1/%a0-%a1,(%a7) "); // save all registers
__asm__ (" jsr NMI_C_Part ");
__asm__ (" movem.l (%a7),%d0-%d1/%a0-%a1 ");
__asm__ (" lea 60(%a7),%a7 ");
__asm__ (" rte");
}


void NMI_C_Part()
{
WORD tmp = sim.pit[1].pcsr; // Get PIT1 Control & Stat
tmp &= 0xFF0F; // Bits 47
tmp |= 0x0F; // Bits 03
sim.pit[1].pcsr = tmp;

if(isr_cnt<10000)
    {
     Addresses[isr_cnt]=saved_a7[1];
     isr_cnt++;
    }
}


void StartProfile()
{
sim.pit[1].pcsr=0;
//
isr_cnt=0;
// Populate the interrupt vector in the interrupt controller. The
// SetIntc() function is supplied by the NetBurner API to make the
// interrupt control register configuration easier
//
SetIntc( ( long ) &NMI_ASM_Part, 36 + 1, 7 /* IRQ2 */, 7 );
//
// Configure the PIT for the specified time values
//
sim.pit[1].pmr = 1000; // Set PIT modulus value
WORD tmp = 4;
tmp = ( tmp << 8 ) | 0x0F;
sim.pit[1].pcsr = tmp; // Set system clock divisor to 16 and

}



void StopProfile()
{
sim.pit[1].pcsr=0;
}


int comp_dword(const void * p1, const void * p2)
{
PDWORD pdw1=(PDWORD)p1;
PDWORD pdw2=(PDWORD)p2;
if((*pdw1)>(*pdw2)) return 1;
if ((*pdw1)<(*pdw2)) return -1;
return 0;

}

void ShowProfile()
{
qsort(Addresses, isr_cnt,sizeof(DWORD),comp_dword);
DWORD la=Addresses[0];
DWORD cnt=0;
iprintf("isrcount = %ld\r\n",isr_cnt);
for (DWORD i=0; i<isr_cnt; i++)
{
if(la==Addresses[i]) cnt++;
else
 {
  iprintf("Address %08X %d times\r\n",la,cnt);
  la=Addresses[i];
  cnt=1;
 }
}
if(cnt!=0)
    iprintf("Address %08X %d times\r\n",la,cnt);

} 
